<?php
// Credit Louviaux Jean-Marc 2015
define('checkaccess', TRUE);
include('../config/config_main.php');

$dir    = '../data/csv/';
$output = glob($dir . '/*.csv');
rsort($output);
if (isset($output[0])) {
    for ($i = 1; $i <= $NUMMETER; $i++) {
        include("../config/config_met$i.php");
        
        if (${'TYPE' . $i} != 'Sensor') {
            $file       = file($output[0]);
            $month      = substr($output[0], -8, 2);
            $day        = substr($output[0], -6, 2);
            $contalines = count($file);
            $prevarray  = preg_split('/,/', $file[1]);
            $linearray  = preg_split('/,/', $file[$contalines - 1]);
            
            $val_first = $prevarray[$i];
            $val_last  = $linearray[$i];
            settype($val_first, 'float');
            settype($val_last, 'float');
            
            if (${'TYPE' . $i} == 'Elect') {
                if ($val_last <= 1000) {
                    $prefix  = '';
                    $val_tot = number_format($val_last, 0, $DPOINT, $THSEP);
                } elseif ($val_last > 1000) {
                    $val_tot = $val_last / 1000;
                    $prefix  = 'k';
                    $val_tot = number_format($val_tot, 3, $DPOINT, $THSEP);
                }
            } else {
                settype(${'PRECI' . $i}, 'integer');
                $val_tot = number_format($val_last, ${'PRECI' . $i}, $DPOINT, $THSEP);
                $prefix  = '';
            }
            $data["Totalcounter$i"] = "$val_tot $prefix";
            
            if ($val_first <= $val_last) {
                $val_last -= $val_first;
            } else { // counter pass over
                $val_last += ${'PASSO' . $i} - $val_first;
            }
            
            if (${'TYPE' . $i} == 'Elect') {
                if ($val_last <= 1000) {
                    $prefix   = '';
                    $val_last = number_format($val_last, 0, $DPOINT, $THSEP);
                } elseif ($val_last > 1000) {
                    $val_last /= 1000;
                    $prefix   = 'k';
                    $val_last = number_format($val_last, 3, $DPOINT, $THSEP);
                }
            } else {
                settype(${'PRECI' . $i}, 'integer');
                $val_last = number_format($val_last, ${'PRECI' . $i}, $DPOINT, $THSEP);
                $prefix   = '';
            }
            $data["Dailycounter$i"] = "$val_last $prefix";
            
        } else {
            $data["Totalcounter$i"] = '--';
            $data["Dailycounter$i"] = '--';
        }
    }
} else {
    for ($i = 1; $i <= $NUMMETER; $i++) {
        $data["Totalcounter$i"] = '--';
        $data["Dailycounter$i"] = '--';
    }
}

header("Content-type: text/json");
echo json_encode($data);
?>
