<?php
// Credit Louviaux Jean-Marc 2015
include('loadcfg.php');
while (true) { // To infinity ... and beyond!
    for ($metnum = 1; $metnum <= $NUMMETER; $metnum++) { // Meters/Sensors pooling
        ///// Main memory
        $shmid = shmop_open($MEMORY, 'a', 0, 0);
        $size  = shmop_size($shmid);
        shmop_close($shmid);
        
        $shmid        = shmop_open($MEMORY, 'c', 0644, $size);
        $memarraydata = shmop_read($shmid, 0, $size);
        shmop_close($shmid);
        $memarray = json_decode($memarraydata, true);
        
        ///// Live memory
        $shmid = shmop_open($LIVEMEMORY, 'a', 0, 0);
        $size  = shmop_size($shmid);
        shmop_close($shmid);
        
        $shmid = shmop_open($LIVEMEMORY, 'c', 0644, $size);
        $data  = shmop_read($shmid, 0, $size);
        shmop_close($shmid);
        $livememarray = json_decode($data, true);
        /////
        
        if (!${'SKIPMONITORING' . $metnum} && ${'LIVEPOOL' . $metnum} != 0) {
            $datareturn = exec(${'LIVECOMMAND' . $metnum});
            $datareturn = trim($datareturn);
            $val        = isvalid(${'LID' . $metnum}, $datareturn);
            if (isset($val)) {
                $livememarray['UTC'] = strtotime(date('Ymd H:i:s'));
            } else {
                $val                 = 0;
                $livememarray['UTC'] = '0';
            }
        } else {
            $val                 = 0;
            $livememarray['UTC'] = strtotime(date('Ymd H:i:s'));
        }
        
        $livememarray["${'METNAME'.$metnum}$metnum"] = floatval($val); // Live value or state
        
        $minute   = date('i');
        $fiveflag = (bool) $memarray['5minflag'];
        
        if (in_array($minute, $minlist) && !$memarray['5minflag']) { // 5 min jobs
            $memarray['5minflag'] = true;
            $today                = date('Ymd');
            
            if (!file_exists($DATADIR . "/csv/$today.csv")) { // Midnight or startup
                $stringData = "Time"; // Header line
                for ($i = 1; $i <= $NUMMETER; $i++) {
                    $stringData .= ",${'METNAME'.$i}(${'UNIT'.$i})";
                }
                $stringData .= "\r\n";
                file_put_contents($DATADIR . "/csv/$today.csv", $stringData, FILE_APPEND);
                
                $csvlist = glob($DATADIR . '/csv/*.csv');
                sort($csvlist);
                $xdays = count($csvlist);
                
                if ($xdays > 1) {
                    $lines      = file($csvlist[$xdays - 2]); // Yesterday consumption
                    $contalines = count($lines);
                    $csvdate1   = substr($csvlist[$xdays - 2], -8, 4);
                    $year       = (int) substr($csvlist[$xdays - 2], -12, 4); // For new year
                    $day1       = date('d');
                    
                    for ($i = 1; $i <= $NUMMETER; $i++) {
                        $memarray["Mailflag$i"] = false; // clear Mailflag
                        
                        if (${'TYPE' . $i} != 'Sensor') {
                            $val_last  = null;
                            $val_first = null;
                            $j         = 0;
                            while (!isset($val_first)) {
                                $j++;
                                $array     = preg_split('/,/', $lines[$j]);
                                $val_first = trim($array[$i]);
                                if ($val_first == '') { // if skipped
                                    $val_first = null;
                                }
                                if ($j == $contalines - 1) {
                                    $val_first = 0; // didn't find any prev. first value
                                }
                            }
                            $j = 0;
                            while (!isset($val_last)) {
                                $j++;
                                $array    = preg_split('/,/', $lines[$contalines - $j]);
                                $val_last = trim($array[$i]);
                                if ($val_last == '') {
                                    $val_last = null;
                                }
                                if ($j == $contalines - 1) {
                                    $val_last = 0;
                                }
                            }
                            settype($val_last, 'float');
                            settype($val_first, 'float');
                            
                            if ($val_first <= $val_last) {
                                $val_last -= $val_first;
                            } else { // counter pass over
                                $val_last += ${'PASSO' . $i} - $val_first;
                            }
                            $val_last   = round($val_last, ${'PRECI' . $i});
                            $stringData = "$csvdate1";
                            $stringData .= ",$val_last\r\n";
                            
                            file_put_contents($DATADIR . '/meters/' . $i . ${'METNAME' . $i} . $year . '.csv', $stringData, FILE_APPEND);
                        }
                        // Reports
                        if (${'REPORT' . $i} == 'daily') { // Daily
                            $month = (int) substr($date1, 0, 2);
                            $day   = (int) substr($date1, 2, 2);
                            $date1 = date($DATEFORMAT, mktime(0, 0, 0, $month, $day, $year));
                            $msg   = "${'METNAME'.$i} $val_last ${'UNIT'.$i}\r\n";
                            if (${'EMAIL' . $i} != 'no@be.org') {
                                mail("${'EMAIL'.$i}", "meterN: $date1 report", $msg);
                            }
                        }
                        if ($day1 == '01' && ${'REPORT' . $i} == 'monthly') { // Monthly
                            $y_year      = date('Y', time() - 60 * 60 * 24); // yesterday
                            $y_month     = date('m', time() - 60 * 60 * 24);
                            $mlines      = file($DATADIR . '/meters/' . $i . ${'METNAME' . $i} . $y_year . '.csv');
                            $mcontalines = count($mlines);
                            $j           = 0;
                            for ($line_num = 0; $line_num < $mcontalines; $line_num++) {
                                $array = preg_split('/,/', $lines[$line_num]);
                                $month = substr($array[0], 0, 2);
                                if ($month == $y_month) {
                                    $month         = substr($array[0], 0, 2);
                                    $day           = substr($array[0], 2, 2);
                                    $dayname[$j]   = date($DATEFORMAT, mktime(0, 0, 0, $month, $day, $y_year));
                                    $conso_day[$j] = $array[1];
                                    //settype($conso_day[$j], 'float');
                                    $conso_day[$j] = round($conso_day[$j], ${'PRECI' . $i});
                                    $j++;
                                }
                            }
                            $conso_month[$i] = round(array_sum($conso_day), ${'PRECI' . $i});
                            $cnt             = count($dayname);
                            $msg             = "${'METNAME'.$i}\t (${'UNIT'.$i})\r\n";
                            for ($j = 0; $j < $cnt; $j++) {
                                $msg .= "$dayname[$j]\t";
                                $msg .= "$conso_day[$j]\r\n";
                            }
                            $msg .= "\r\n";
                            $msg .= "$conso_month[$i] ${'UNIT'.$i} on $y_month $y_year\r\n---\r\n";
                            if (${'EMAIL' . $i} != 'no@be.org') {
                                mail("${'EMAIL'.$i}", "meterN: ${'METNAME'.$i} Monthly $y_month report", $msg);
                            }
                        }
                        // Reports
                    }
                }
                // Morning cleanup
                if ($KEEPDDAYS != 0) {
                    if ($xdays > $KEEPDDAYS) {
                        $i = 0;
                        while ($i < $xdays - $KEEPDDAYS) {
                            unlink($csvlist[$i]);
                            $i++;
                        }
                        $now        = date($DATEFORMAT . ' H:i:s');
                        $stringData = "$now\tPurging $i detailed csv file(s)\n\n";
                        $stringData .= file_get_contents($DATADIR . '/events.txt');
                        file_put_contents($DATADIR . '/events.txt', $stringData);
                    }
                }
                if ($AMOUNTLOG != 0) {
                    $lines = file('../data/events.txt');
                    $cnt   = count($lines);
                    if ($cnt >= $AMOUNTLOG) {
                        $now = date($DATEFORMAT . ' H:i:s');
                        array_splice($lines, $AMOUNTLOG);
                        $file2      = fopen('../data/events.txt', 'w');
                        $new_lignes = "$now\tClean up events log\n\n";
                        fwrite($file2, $new_lignes);
                        fwrite($file2, implode('', $lines));
                        fclose($file2);
                    }
                }
                // End of morning clean up 
            } // End Midnight
            
            for ($i = 1; $i <= $NUMMETER; $i++) { // For each meters
                $datareturn = null;
                $matches    = array();
                $giveup     = 0;
                $lastval    = null;
                
                if (!${'SKIPMONITORING' . $i}) {
                    while (!isset($datareturn) && $giveup < 3) { // Try 3 times
                        $datareturn = exec(${'COMMAND' . $i});
                        $datareturn = trim($datareturn);
                        $lastval    = isvalid(${'ID' . $i}, $datareturn);
                        $giveup++;
                    }
                    if (!isset($lastval)) {
                        $lastval = null;
                    }
                } else {
                    $lastval = null;
                }
                
                if ($i == 1) {
                    $PCtime     = date('H:i');
                    $stringData = "$PCtime";
                }
                $stringData .= ",$lastval";
            } // For each meters
            
            $stringData .= "\r\n";
            file_put_contents($DATADIR . "/csv/$today.csv", $stringData, FILE_APPEND);
            
            $lines      = file($DATADIR . "/csv/$today.csv");
            $contalines = count($lines);
            if ($contalines > 2) { // Consumption/production sensor check
                for ($i = 1; $i <= $NUMMETER; $i++) {
                    $mailflag = (bool) $memarray["Mailflag$i"];
                    if ($mailflag == false) {
                        $array     = preg_split('/,/', $lines[1]);
                        $val_first = trim($array[$i]);
                        $array     = preg_split('/,/', $lines[$contalines - 1]);
                        $val_last  = trim($array[$i]);
                        settype($val_first, 'float');
                        settype($val_last, 'float');
                        
                        if (!empty($val_first) && !empty($val_last) && ${'TYPE' . $i} != 'Sensor') { // Meter
                            if ($val_first <= $val_last) {
                                $val_last -= $val_first;
                            } else { // counter pass over
                                $val_last += ${'PASSO' . $i} - $val_first;
                            }
                        }
                        
                        if ($val_last > ${'WARNCONSOD' . $i} && ${'WARNCONSOD' . $i} != 0 && !${'SKIPMONITORING' . $i}) {
                            
                            $memarray["Mailflag$i"] = true;
                            
                            if (${'PROD' . $i} == 1) {
                                $prodconsu = 'production';
                            } elseif (${'PROD' . $i} == 2) {
                                $prodconsu = 'consumption';
                            } else {
                                $prodconsu = null;
                            }
                            $now        = date($DATEFORMAT . ' H:i:s');
                            $msg        = "$prodconsu reach $val_last ${'UNIT'.$i}";
                            $stringData = "$now\t${'METNAME'.$i} $prodconsu reach $val_last ${'UNIT'.$i}\n\n";
                            if (${'EMAIL' . $i} != 'no@be.org') {
                                mail("${'EMAIL'.$i}", "meterN: ${'METNAME'.$i} $prodconsu warning", $msg);
                            }
                            if (${'PUSHO' . $i} == 1) {
                                $pushover = exec('curl -s -F "title=' . ${'METNAME' . $i} . ' Warning" -F "token=BCZigaCQktVT4zR1xmpZ3iXsmkbm59" -F "user=' . ${'POUKEY' . $i} . '" -F "message=' . $msg . '" https://api.pushover.net/1/messages.json &');
                            }
                            $stringData .= file_get_contents('../data/events.txt');
                            file_put_contents('../data/events.txt', $stringData);
                        }
                    }
                }
            } // Consumption/prod check
        } // 5 min 
        
        
        if (!in_array($minute, $minlist) && $memarray['5minflag']) { // Run once every 1,6,11,16,..
            $memarray['5minflag'] = false; // Reset 5minflag
        }
        
        $data = json_encode($memarray);
        if ($data != $memarraydata) { // Reduce write
            $size  = mb_strlen($data, 'UTF-8');
            $shmid = shmop_open($MEMORY, 'a', 0, 0);
            shmop_delete($shmid);
            shmop_close($shmid);
            
            $shmid = shmop_open($MEMORY, 'c', 0644, $size);
            shmop_write($shmid, $data, 0);
            shmop_close($shmid);
        }
        
        $data = json_encode($livememarray);
        $size = mb_strlen($data, 'UTF-8');
        
        @$shmid = shmop_open($LIVEMEMORY, 'a', 0, 0);
        if (!empty($shmid)) {
            shmop_delete($shmid);
            shmop_close($shmid);
        }
        
        $shmid = shmop_open($LIVEMEMORY, 'c', 0644, $size);
        shmop_write($shmid, $data, 0);
        shmop_close($shmid);
    } // End meters pooling
    usleep($DELAY);
} // infinity
?>